/* -*-C-*-
*******************************************************************************
*
* File:         Preferences.h
* RCS:          /usr/local/sources/CVS/EnhanceMail/Preferences.h,v 1.14 1999/01/07 15:05:06 tom Exp
* Description:  
* Author:       Carl Edman
* Created:      Wed Nov  1 09:57:52 1995
* Modified:      7-Nov-97 (Tom Hageman)
* Language:     C
* Package:      N/A
* Status:       Experimental (Do Not Distribute)
*
* (C) Copyright 1995, but otherwise this file is perfect freeware.
*
*******************************************************************************
*/

#import <appkit/appkit.h>
#import "MailApp.h"

#ifndef PREFEXTERN
#define PREFEXTERN extern
#endif

PREFEXTERN BOOL EnhanceQuoteReplies;
PREFEXTERN BOOL EnhanceQuoteColoring;
PREFEXTERN BOOL EnhanceQuoteColoringInMailbox;
PREFEXTERN BOOL EnhanceRemoveCellDroppings;
PREFEXTERN BOOL EnhanceLaunchMailboxes;
PREFEXTERN BOOL EnhanceLaunchAddresses;
PREFEXTERN BOOL EnhanceInsertSignature;
PREFEXTERN BOOL EnhanceRepliesWithOriginals;
PREFEXTERN BOOL EnhanceRestoreDeletesDraft;
PREFEXTERN BOOL EnhanceInsertXFace;
PREFEXTERN BOOL EnhanceInsertXImageURL;
PREFEXTERN BOOL EnhanceBackSpaceBackPages;
PREFEXTERN BOOL EnhanceAutoCompact;
PREFEXTERN BOOL EnhanceAutoSpellCheck;
PREFEXTERN BOOL EnhanceShowXFace;
PREFEXTERN BOOL EnhanceShowXImageURL;
PREFEXTERN BOOL EnhanceFlagReplies;
PREFEXTERN BOOL EnhanceExpandSmilies;
PREFEXTERN BOOL EnhanceUsePGP;
PREFEXTERN BOOL EnhanceRetrievePGPKeys;
PREFEXTERN BOOL EnhancePGPSign;
PREFEXTERN BOOL EnhancePGPEncrypt;
PREFEXTERN BOOL	EnhancePGPPassAskForSigning;
PREFEXTERN BOOL EnhancePGPFancyStatusDisplay;
PREFEXTERN BOOL EnhanceSilentNewMail;
PREFEXTERN BOOL EnhanceCheckPendingAppnmail;
PREFEXTERN BOOL EnhanceUseFixedPitchFontForPlainMessages;
PREFEXTERN BOOL EnhanceShowFlagged;
PREFEXTERN BOOL EnhanceUseTextColorInMailbox;
PREFEXTERN BOOL EnhanceUseTextColorInCompose;
PREFEXTERN const char *EnhanceKeyServerURL;
PREFEXTERN const char *EnhancePGPPath;
PREFEXTERN const char *EnhanceQuoteIntro;
PREFEXTERN const char *EnhanceQuotePrefix;
PREFEXTERN const char *EnhanceQuoteRegex;
PREFEXTERN const char *EnhanceXFace;
PREFEXTERN const char *EnhanceXImageURL;
PREFEXTERN const char *EnhanceSignatureSeparator;
PREFEXTERN const char *EnhanceSignatureFilename;
PREFEXTERN const char *EnhanceHTTPProxy;
PREFEXTERN const char *EnhanceSmilies;
PREFEXTERN const char *EnhanceFlagSearchString;
PREFEXTERN const char *EnhancePreSelExtra;
PREFEXTERN const char *EnhancePostSelExtra;
PREFEXTERN int EnhancePGPPassTimeout;
PREFEXTERN int EnhancePGPVersion;
PREFEXTERN int EnhanceMailboxCheckInterval;
PREFEXTERN NXColor EnhanceQuoteColor;
PREFEXTERN NXColor EnhanceTextBackgroundColor;
PREFEXTERN NXColor EnhanceTextColor;
PREFEXTERN unsigned EnhanceMaxTocCheckSize;
PREFEXTERN unsigned EnhanceMaxSmileyExpansionMessageSize;
PREFEXTERN unsigned EnhanceMaxQuoteColorMessageSize;

extern void EnhanceSetTextColor(id text, BOOL enable);


@interface EnhancePreferences:Preferences
- setXFace:sender;

- noteChangePassPhraseTimeout:sender;
- noteChangeXFace:sender;
- noteChangeXImageURL:sender;

- controlFor:(const void *)location;
- addPanel:panel;

- registerBool:(const char *)name location:(BOOL *)loc control:(const char *)con default:(BOOL)def;
- registerString:(const char *)name location:(const char **)loc control:(const char *)con default:(const char *)def;
- registerInteger:(const char *)name location:(int *)loc control:(const char *)con default:(int)def;
- registerColor:(const char *)name location:(NXColor *)loc control:(const char *)con default:(NXColor)def;
@end
