/* -*-ObjC-*-
*******************************************************************************
*
* File:         TransferPanel.h
* RCS:          TransferPanel.h,v 1.12 1998/10/15 22:22:03 tom Exp
* Description:  
* Author:       Tom Hageman <tom@basil.icce.rug.nl>
* Created:      October 1996
* Modified:     April 1998
* Language:     Objective-C
* Package:      EnhanceMail
* Status:       Experimental
*
* Copyright (C) 1996-1998 Tom Hageman, but otherwise this file is perfect freeware.
*
*******************************************************************************
*/

#import <appkit/appkit.h>
#import "MailApp.h"

@interface EnhanceTransferPanel : TransferPanel

- (void)updateBrowser;
- (void)updateBrowser:(BOOL)force;
- (void)updateBrowserForMailBoxNamed:(const char *)mailboxName;
- (void)updateMessageCount:(unsigned)newMessageCount old:(unsigned)oldMessageCount
   forMailBoxNamed:(const char *)mailBoxName isNew:(BOOL)isNew;
- (void)updateFlaggedCountBy:(int)increment forMailBoxNamed:(const char *)mailBoxName;

- (void)setNewMailFlagForMailBoxNamed:(const char *)mailBoxName;

- (void)loadMailSummaries:(BOOL)reload;

- (BOOL)checkNewMailForReader:(MailReader *)reader;

- (void)flushSummaryCache;

@end // EnhanceTransferPanel


@interface EnhanceMailboxBrowserCell : NXBrowserCell
{
   long numMessages;
   BOOL	pending;
   BOOL newMail;
   signed char scan;
   signed char status;
   signed char kind;
}

- (long)numMessages;
- setNumMessages:(long)value;

- (BOOL)pending;
- setPending:(BOOL)value;

- (BOOL)newMail;
- setNewMail:(BOOL)value;

- (int)scan;
- setScan:(int)value;

- (int)status;
- setStatus:(int)value;

- (int)kind;
- setKind:(int)value;

@end // EnhanceMailboxBrowserCell
