/* -*-ObjC-*-
*******************************************************************************
*
* File:         XImageAliases.h
* RCS:          XImageAliases.h,v 1.1 1998/06/27 00:58:25 tom Exp
* Description:  Interface of EnhanceXImageAliases class.
* Author:       Tom Hageman <tom@basil.icce.rug.nl>
* Created:      June 1998
* Modified:     
* Language:     Objective-C
* Package:      EnhanceMail
* Status:       Experimental
*
* Copyright (C) 1998 Tom Hageman, but otherwise this file is perfect freeware.
*
*******************************************************************************
*/
#import <sys/stat.h>
#import <objc/Object.h>
#import <objc/HashTable.h>


@interface EnhanceXImageAliases : Object
{
   char *dirname;		// directory name.
   HashTable *addr2urlHash;	// one-to-one
   HashTable *url2addrHash;	// potentially one-to-many
   char *fullpathbuf;		// result buffer (recycled.)

   struct stat stat_cache;	// For up-to-date check.
}

+ (EnhanceXImageAliases *)aliasesForDirectory:(const char *)dir;
- initFromDirectory:(const char *)dir;

- (const char *)urlForAddress:(const char *)mailAddress;
- (const char *)addressForURL:(const char *)url;
   // access methods.

- (const char *)fileForAddress:(const char *)mailAddress;
- (const char *)fileForURL:(const char *)url;
   // return full path if file found, NULL otherwise.

//- (const char *)urlForFile:(const char *)file;
   // XXX Lossy url -> filename mapping...

- (void)recordURL:(const char *)url forAddress:(const char *)addr;
   // (persistently) record URL for email address.

@end // EnhanceXImageAliases


@interface EnhanceXImageAliases (PathUtils)

+ (const char *)getPathName:(char *)buf forURL:(const char *)url;

- (const char *)getPath:(char *)buf forURL:(const char *)url;
- (const char *)getPath:(char *)buf forFile:(const char *)file;

@end // EnhanceXImageAliases (PathUtils)
